/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package im.kurt.resumeapi;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * @author ksiegfried
 */
public class Job implements Serializable {

    private String employer;
    private String title;
    private String description;
    private String city;
    private String state;
    private Date startDate;
    private Date endDate;

    public static class JobBuilder {

        private final Job _job = new Job();
        private boolean done = false;

        public Job build() {
            done = true;
            return _job;
        }

        public JobBuilder setEmployer(String employer) {
            check();
            _job.employer = employer;
            return this;
        }

        public JobBuilder setTitle(String title) {
            check();
            _job.title = title;
            return this;
        }

        public JobBuilder setDescription(String description) {
            check();
            _job.description = description;
            return this;
        }

        public JobBuilder setCity(String city) {
            check();
            _job.city = city;
            return this;
        }

        public JobBuilder setState(String state) {
            check();
            _job.state = state;
            return this;
        }

        public JobBuilder setStartDate(Date startDate) {
            check();
            _job.startDate = startDate;
            return this;
        }

        public JobBuilder setEndDate(Date endDate) {
            check();
            _job.endDate = endDate;
            return this;
        }

        private void check() {
            if (done) {
                throw new IllegalArgumentException("Do use other builder to create new instance");
            }
        }
    }

    /**
     * @return the employer
     */
    public String getEmployer() {
        return employer;
    }

    /**
     * @param employer the employer to set
     */
    public void setEmployer(String employer) {
        this.employer = employer;
    }

    /**
     * @return the title
     */
    public String getTitle() {
        return title;
    }

    /**
     * @param title the title to set
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * @return the description
     */
    public String getDescription() {
        return description;
    }

    /**
     * @param description the description to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * @return the city
     */
    public String getCity() {
        return city;
    }

    /**
     * @param city the city to set
     */
    public void setCity(String city) {
        this.city = city;
    }

    /**
     * @return the state
     */
    public String getState() {
        return state;
    }

    /**
     * @param state the state to set
     */
    public void setState(String state) {
        this.state = state;
    }

    /**
     * @return the startDate
     */
    public Date getStartDate() {
        return startDate;
    }

    /**
     * @param startDate the startDate to set
     */
    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    /**
     * @return the endDate
     */
    public Date getEndDate() {
        return endDate;
    }

    /**
     * @param endDate the endDate to set
     */
    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }
}
