/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package im.kurt.resumeapi;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * @author ksiegfried
 */
public class School implements Serializable {

    private String name;
    private String city;
    private String state;
    private String major;
    private String minor;
    private String degree;
    private Double gpa;
    private Date startDate;
    private Date endDate;

    public static class SchoolBuilder {

        private final School _school = new School();
        private boolean done = false;

        public School build() {
            done = true;
            return _school;
        }

        public SchoolBuilder setName(String name) {
            check();
            _school.name = name;
            return this;
        }

        public SchoolBuilder setGPA(Double GPA) {
            check();
            _school.gpa = GPA;
            return this;
        }

        public SchoolBuilder setMinor(String minor) {
            check();
            _school.minor = minor;
            return this;
        }

        public SchoolBuilder setDegree(String degree) {
            check();
            _school.degree = degree;
            return this;
        }

        public SchoolBuilder setMajor(String major) {
            check();
            _school.major = major;
            return this;
        }

        public SchoolBuilder setCity(String city) {
            check();
            _school.city = city;
            return this;
        }

        public SchoolBuilder setState(String state) {
            check();
            _school.state = state;
            return this;
        }

        public SchoolBuilder setStartDate(Date startDate) {
            check();
            _school.startDate = startDate;
            return this;
        }

        public SchoolBuilder setEndDate(Date endDate) {
            check();
            _school.endDate = endDate;
            return this;
        }

        private void check() {
            if (done) {
                throw new IllegalArgumentException("Do use other builder to create new instance");
            }
        }
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the major
     */
    public String getMajor() {
        return major;
    }

    /**
     * @param major the major to set
     */
    public void setMajor(String major) {
        this.major = major;
    }

    /**
     * @return the minor
     */
    public String getMinor() {
        return minor;
    }

    /**
     * @param minor the minor to set
     */
    public void setMinor(String minor) {
        this.minor = minor;
    }

    /**
     * @return the degree
     */
    public String getDegree() {
        return degree;
    }

    /**
     * @param degree the degree to set
     */
    public void setDegree(String degree) {
        this.degree = degree;
    }

    /**
     * @return the gpa
     */
    public Double getGpa() {
        return gpa;
    }

    /**
     * @param gpa the gpa to set
     */
    public void setGpa(Double gpa) {
        this.gpa = gpa;
    }

    /**
     * @return the city
     */
    public String getCity() {
        return city;
    }

    /**
     * @param city the city to set
     */
    public void setCity(String city) {
        this.city = city;
    }

    /**
     * @return the state
     */
    public String getState() {
        return state;
    }

    /**
     * @param state the state to set
     */
    public void setState(String state) {
        this.state = state;
    }
}
